# $Id: Static.pm 1820 2009-09-28 18:55:19Z wsl $
# $URL: http://svn.zo.oi/wsl/src/libxyzzy-perl/lib/Xyzzy/Static.pm $

use utf8;
use strict;
use warnings FATAL => 'all';

package Xyzzy::Static;

use Xyzzy::Generator -Base;

use Apache2::Const;

sub build {
	my $doc = $self->doc;
	my $cfg = $self->cfg;
	my $rec = $self->rec;

	my @path = @{$self->fullpath};
	foreach(@path) {
		unless(/^[a-z0-9]+([._,-]+[a-z0-9]+)*$/i) {
			warn 'Bad path: '.join('/', @path)."\n";
			return $self->code(Apache2::Const::FORBIDDEN);
		}
	}
	my $path = join('/', $cfg->staticrootdir, @path) . '.xml';

	return $self->code(Apache2::Const::NOT_FOUND) unless -f $path;
	return $self->code(Apache2::Const::FORBIDDEN) unless -r _;

	$self->addTemplates('base');
	$doc->addContent($path);
	$rec->filename($path);
}
